program name2hex;

{$APPTYPE CONSOLE}

uses
  SysUtils;

function str2hex(str:string):string;
var
i : integer;
new : string;
begin
 for i:=1 to length(str) do
 if i<>(length(str)-length(ExtractFileExt(str))+1) then
 new:=new+IntToHex(ord(str[i]),2)
 else new:=new+'.';
 Result := new;
end;

function hex2str(hex:string):string;
var
new : string;
substr : string[2];
namelength : integer;
i : integer;
begin
 if (not Odd(length(hex))) then
  begin
   writeln('Error: wrong hex file name.');
   halt;
  end;
 namelength := length(hex)-length(ExtractFileExt(hex));
 for i:=1 to length(hex) do
 if i<>(namelength+1) then
  begin
   if (Odd(i) and (i<namelength)) or ((not Odd(i)) and (i>namelength)) then
    begin
     substr[1]:=hex[i];
     substr[2]:=hex[i+1];
     try
      new := new + chr(StrToInt('$'+substr));
     except
      writeln('Error: wrong hex file name.')
     end;
    end;
  end
 else new:=new+'.';
 Result := new;
end;

var
old_name, new_name : string;

begin
  if (
      (ParamCount = 0) or
      ((ParamCount = 2) and (ParamStr(2)<>'-r')) or
      (ParamCount > 2)
     )
   then
   begin
    writeln('Usage:');
    writeln('name2hex.exe <filename.ext> [-r]');
    writeln('Use -r to decode original filename');
    exit;
   end;

  if not FileExists(ParamStr(1)) then
   begin
    writeln('File '+ParamStr(1)+' does not exist');
    exit;
   end;

  old_name:=ParamStr(1);
  new_name:='';

  if ParamStr(2)='-r' then
   new_name := hex2str(old_name)
  else
   new_name := str2hex(old_name);

  if not RenameFile(old_name, new_name) then
   begin
    writeln('Error: file rename failed');
    exit;
   end;

end.
